#cs #######################################################################

 AutoIt Version: 3.3.6.1
 Author:         Greenhorn

 Script Function:
	Traymen mit Kontextmen.

#ce #######################################################################

#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>
#include <Constants.au3>

#include "ShellNotify.au3"

; Fenstermen
Global $IDM_FILE, $IDM_FILE_NEW, $IDM_APP_EXIT
; Popupmen
Global $IDM_POPUP, $IDM_POPUP_PREFS
; Traymen
Global $IDM_TRAY, _
	  $IDM_TRAY_EXIT, $IDM_TRAY_ABOUT
; Trayicon
Global $IDI_TRAY


Exit (Main ($CmdLine))


Func Main ($aCmdLine)

	Local $hwnd


	;-- Testfenster erzeugen.

	$hwnd = GUICreate ("Test")

	;-- Fenstermen erzeugen/initialisieren.
	$IDM_FILE = GUICtrlCreateMenu ("&Datei")
	$IDM_FILE_NEW = GUICtrlCreateMenuItem ("&Neu", $IDM_FILE)
	$IDM_APP_EXIT = GUICtrlCreateMenuItem ("&Beenden", $IDM_FILE)

	GUISetState (@SW_SHOW, $hwnd)


	;-- Symbol im Infobereich der Taskleiste erzeugen

	$IDI_TRAY = CreateNotifyIcon (0, "TrayIcon", @AutoItExe, 0)
	SetNotifyIconCommand ($IDI_TRAY, 16)	; Rechtsklick

	;-- Kontextmen fr das Symbol
	;   im Infobereich der Taskleiste erzeugen.

	$IDM_TRAY = CreateNotifyPopupMenu ($IDI_TRAY)
	$IDM_TRAY_ABOUT = GUICtrlCreateMenuItem ("&Info",    $IDM_TRAY)
	$IDM_TRAY_EXIT	 = GUICtrlCreateMenuItem ("&Beenden", $IDM_TRAY)

	;-- Kontextmen fr das Traymen initialisieren.

	InitPopupMenu ( )

	;-- Symbol im Infobereich der Taskleiste zeigen.

	SetNotifyIconState ($IDI_TRAY, $NIS_SHOW)

	While (TRUE)

		Switch (GUIGetMsg (FALSE))

			Case $GUI_EVENT_CLOSE
				ContinueCase
			Case $IDM_APP_EXIT
				ContinueCase
			Case $IDM_TRAY_EXIT
				ExitLoop
			Case $IDM_TRAY_ABOUT
				AboutDlg ("Traymen mit Kontextmen")
			Case Else
				ContinueLoop
		EndSwitch
	WEnd

	;-- Symbol aus dem Infobereich der Taskleiste entfernen !

	DeleteNotifyIcon ($IDI_TRAY)

	Return 0

EndFunc

Func AboutDlg ($szName)

	Local $szText = StringFormat ("ber %s\nCopyright  2010", $szName)
	Return MsgBox (BitOR ($MB_ICONASTERISK, $MB_OK), $szName, $szText)

EndFunc

Func InfoMsg ($szText)

	Local $szTxt = StringFormat ("%s\n", $szText)
	Return MsgBox (BitOR ($MB_ICONASTERISK, $MB_OK), "Info", $szTxt)

EndFunc

Func InitPopupMenu ( )

	;-- Das Kontextmen reagiert ber GUIGetMsg versptet, also
	;   mssen wir WM_COMMAND per GUIRegisterMsg bearbeiten.

	GUIRegisterMsg ($WM_COMMAND, "WM_COMMAND")

	;-- WM_MENURBUTTONUP ist der Schlssel fr unser Vorhaben.

	GUIRegisterMsg ($WM_MENURBUTTONUP, "WM_MENURBUTTONUP")

	$IDM_POPUP = GUICtrlCreateContextMenu (GUICtrlCreateDummy ( ))
	$IDM_POPUP_PREFS = GUICtrlCreateMenuItem ("Eigenschaften", $IDM_POPUP)

	Return

EndFunc

Func WM_COMMAND ($hwnd, $message, $wParam, $lParam)

	Switch (BitAND ($wParam, 0xffff))

		Case $IDM_POPUP_PREFS
			InfoMsg ("Kontextmen")
	EndSwitch


	Return $GUI_RUNDEFMSG

EndFunc

Func WM_MENURBUTTONUP ($hwnd, $message, $wParam, $lParam)

	;-- wParam und lParam enthalten Informationen ber das Men
	;   und das Element auf dem ein Rechtsklick ausgefhrt wurde.

	ConsoleWrite ("--- wParam: "&$wParam & @CRLF) ; Position des Menelements
	ConsoleWrite ("--- lParam: "&$lParam & @CRLF) ; Handle des Mens

	Local $aCursorPos, $mii


	;-- Informationen ber das Element einholen.

	;-- Fr den Text des Elements einen Puffer anlegen.

	$szBuffer = DllStructCreate ("wchar [256]")

	$mii = DllStructCreate ($MENUITEMINFO)

	DllStructSetData ($mii, "cbSize", DllStructGetSize ($mii))
	DllStructSetData ($mii, "fMask", BitOR ($MIIM_ID, $MIIM_SUBMENU, $MIIM_STRING))
	DllStructSetData ($mii, "dwTypeData", DllStructGetPtr ($szBuffer))
	DllStructSetData ($mii, "cch", 256)

	GetMenuItemInfo ($lParam, $wParam, TRUE, DllStructGetPtr ($mii))

	;-- Informationen ber das Element in der Konsole anzeigen.

	DebugStruct ($mii, $MENUITEMINFO, "MENUITEMINFO")
	DebugStruct ($szBuffer, "wchar [256]", "szBuffer")


	;-- Unser Kontextmen anzeigen.

	$aCursorPos = MouseGetPos ( )

	If (IsArray ($aCursorPos)) Then

		TrackPopupMenuEx (GUICtrlGetHandle ($IDM_POPUP), _
			$TPM_RECURSE, $aCursorPos[0], $aCursorPos[1], _
			$hwnd, 0)
	EndIf

	Return $GUI_RUNDEFMSG

EndFunc

;

Func DebugStruct (ByRef $struct, $sStruct, $sStructName = "")

	Local $i		= 1
	Local $val
	Local $asStruct
	Local $bMembername = FALSE

	If (not IsDllStruct ($struct)) Then _
		Return ConsoleWrite ("!> Ungltige Struktur !" & @crlf)

	If ($sStruct) Then

		If (StringRegExp ($sStruct, ";\h?\w+", 0)) Then

			$asStruct = StringRegExp ($sStruct, "(\w+\h?\[?\d?\d?\d?\d?\d?\]?;)", 3)

			If (IsArray ($asStruct)) Then _
				$bMembername = TRUE
		EndIf
	EndIf

	ConsoleWrite ("--- Debug Struct "&$sStructName&" ---" & @crlf)

	While (True)

		$val = DllStructGetData ($struct, $i)

		If (@error) Then
			ExitLoop
		EndIf

		If (IsArray ($asStruct)) Then

			ConsoleWrite (StringFormat ("> %-20s = %s\n", $asStruct[$i - 1], $val))
		Else
			ConsoleWrite ("> " & $i & " = " &$val & @crlf)
		EndIf

		$i += 1
	WEnd

	ConsoleWrite ("--------------------" & @crlf)

EndFunc


